<script lang="ts">
import Vue from 'vue';
// import { getPageMetadata } from '~/common/meta';
import { NextStep } from '~/components/common/index.vue';
import {
  Careers,
  Conduct,
  EventSection,
  EventsSchedule,
  FeaturedContent,
  FeaturedSpeaker,
  Intro,
  LightningHero,
  Party,
  SpeakerSession,
} from '~/components/events/index.vue';
import {
  Agenda,
  CityHero,
  ConductBanner,
  Sponsor,
  WorldTourForm,
  WorldTourFormMulti,
} from '~/components/events/world-tour/index.vue';
import { KubeconLightingTalk } from '~/components/events/kubecon/index.vue';
import { FooterEditLinkMixin, LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful';

export default Vue.extend({
  components: {
    LightningHero,
    Intro,
    EventSection,
    KubeconLightingTalk,
    EventsSchedule,
    SpeakerSession,
    Careers,
    Conduct,
    NextStep,
    Party,
    FeaturedSpeaker,
    FeaturedContent,
    Agenda,
    CityHero,
    ConductBanner,
    Sponsor,
    WorldTourForm,
    WorldTourFormMulti,
  },
  nuxtI18n: false,
  mixins: [FooterEditLinkMixin, LivePreviewMixin],
  fetchOnServer: false,
  data() {
    return {
      icons: [
        'bulb-bolt-96px',
        'code-96px',
        'celebrate-icon_celebrate-96px',
        'tee-96px',
      ],
      eventSlugs: {
        AWS_REINVENT: 'aws-reinvent',
        KUBECON: 'kubecon',
        RSA: 'rsa',
      },
      content: null,
      items: [],
      spaceId: '',
      entryId: '',
      eventType: '',
    };
  },
  async fetch() {
    const id = this.$route.query.id;
    const config = {
      accessToken: this.$config.preview,
      space: this.$config.space,
      host: 'preview.contentful.com',
    };
    try {
      const { items } = await getClient(config).getEntries({
        content_type: CONTENT_TYPES.EVENT,
        'sys.id': id,
        include: 4,
      });
      const [eventPage] = items;
      this.eventType = eventPage.fields.eventType;
      if (
        this.eventType === 'Connect' ||
        this.eventType === 'World Tour' ||
        this.eventType === 'World Tour Executive'
      ) {
        this.content = this.$worldTourEventsService.getWorldTourEvent(
          eventPage.fields,
        );
      } else {
        this.content = this.$eventsService.transformEventData(eventPage.fields);
      }

      this.items = items;
      this.spaceId = eventPage.sys.space.sys.id;
      this.entryId = eventPage.sys.id;
    } catch (e) {
      throw new Error(e);
    }
  },
  // head() {
  //   try {
  //     const metadata = {
  //       ...(this.content.metadata || {}),
  //       noIndex: true,
  //     };
  //     return getPageMetadata(
  //       metadata,
  //       this.$route.path,
  //       this.$nuxtI18nHead({ addSeoAttributes: true }),
  //     );
  //   } catch (e) {
  //     throw new Error(e);
  //   }
  // },
  computed: {
    showFeaturedSpeaker() {
      return this.$route.params.slug === this.eventSlugs.RSA;
    },
    showKubeconLighting() {
      return this.$route.params.slug === this.eventSlugs.KUBECON;
    },
    showParty() {
      return this.$route.params.slug === this.eventSlugs.AWS_REINVENT;
    },
    showSessions() {
      return this.$route.params.slug !== this.eventSlugs.RSA;
    },
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          this.eventType === 'Connect' ||
          this.eventType === 'World Tour' ||
          this.eventType === 'World Tour Executive'
            ? (this.content =
                this.$worldTourEventsService.getWorldTourEvent(updatedData))
            : (this.content =
                this.$eventsService.transformEventChildData(updatedData)),
      });

      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div v-if="!$fetchState.pending">
    <div
      v-if="eventType === 'Connect' || 'World Tour' || 'World Tour Executive'"
    >
      <CityHero
        v-if="city.hero"
        v-bind="city.hero"
        :registration-closed="city.form?.registrationClosed"
        :location="city.location"
        :date="city.date"
      />
      <Agenda
        v-if="city.agenda"
        v-bind="city.agenda"
        :registration-closed="city.form?.registrationClosed"
        :location="city.location"
      />
      <WorldTourFormMulti
        v-if="city.form && city.form.multiStepForm"
        v-bind="city.form"
      />

      <WorldTourForm
        v-if="city.form && !city.form.multiStepForm"
        v-bind="city.form"
      />

      <Sponsor v-if="city.sponsors" v-bind="city.sponsors[0]" />

      <div v-if="city.footnote">
        <ConductBanner
          v-for="footnote in city.footnote"
          :key="footnote.header"
          v-bind="footnote"
          class="city__section"
        />
      </div>

      <SlpContainer v-if="city.nextSteps" variant="gradient">
        <NextStep :variant="city.nextSteps" />
      </SlpContainer>
    </div>
    <div v-else-if="eventType === 'Standard'">
      <LightningHero
        v-if="content.hero"
        :data="content.hero"
        :icons="icons"
        :dark-mode="content.hero.darkMode"
      />

      <Intro v-if="content.description" :data="content.description" />

      <div v-if="content.booth">
        <EventSection
          v-for="(item, index) in content.booth"
          :key="item.header"
          :reverse="index % 2 !== 0"
          class="slp-pb-32"
          :data="item"
        />
      </div>

      <!-- RSA SPEAKER SECTION -->
      <div v-if="content.sessions && showFeaturedSpeaker">
        <FeaturedSpeaker
          v-for="(session, sessionIndex) in content.sessions"
          :key="sessionIndex"
          :data="session"
        />
      </div>

      <div v-if="content.featuredContent">
        <template v-if="showKubeconLighting">
          <KubeconLightingTalk
            v-for="feature in content.featuredContent"
            :key="feature.header"
            :data="feature"
          />
        </template>
        <template v-else>
          <FeaturedContent
            v-if="content.featuredContent"
            :data="content.featuredContent"
          />
        </template>
      </div>

      <div v-if="content.social">
        <template v-if="showParty">
          <party
            v-for="item in content.social"
            :key="item.header"
            :data="item"
          />
        </template>
        <template v-else>
          <EventSection
            v-for="socialEvent in content.social"
            :key="socialEvent.header"
            :has-gradient="$route.params.slug !== eventSlugs.RSA"
            :icon="'celebrate-24px'"
            class="slp-py-160"
            :data="socialEvent"
          />
        </template>
      </div>

      <div v-if="content.sessions && showSessions">
        <SpeakerSession
          v-for="(session, sessionIndex) in content.sessions"
          :key="sessionIndex"
          :data="session"
        />
      </div>

      <EventsSchedule v-if="content.agenda" :data="content.agenda" />

      <Careers v-if="content.careers" :data="content.careers" />

      <div v-if="content.footnote">
        <Conduct
          v-for="footnote in content.footnote"
          :key="footnote.header"
          :data="footnote"
        />
      </div>

      <NextStep :variant="content.nextSteps" />
    </div>
  </div>
</template>
